﻿using Infragistics.Web.Mvc;
using remoteFIltering.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace remoteFIltering.Controllers
{
    public class HomeController : Controller
    {
        //DateTime date = DateTime.Now;

        private IEnumerable<Product> GetData()
        {
            List<Product> list = new List<Product>();
            list.Add(new Product() { ProductID = 1, ProductName = "ProductName 1", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 2, ProductName = "ProductName 2", StartDate = "2016/12/14" });
            list.Add(new Product() { ProductID = 3, ProductName = "ProductName 3", StartDate = "2016/12/14" });
            list.Add(new Product() { ProductID = 4, ProductName = "ProductName 4", StartDate = "2016/12/14" });
            list.Add(new Product() { ProductID = 5, ProductName = "ProductName 5", StartDate = "2016/12/14" });
            list.Add(new Product() { ProductID = 6, ProductName = "ProductName 6", StartDate = "2016/12/14" });
            list.Add(new Product() { ProductID = 7, ProductName = "ProductName 7", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 8, ProductName = "ProductName 8", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 9, ProductName = "ProductName 10", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 10, ProductName = "ProductName 11", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 11, ProductName = "ProductName 12", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 12, ProductName = "ProductName 13", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 13, ProductName = "ProductName 13", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 14, ProductName = "ProductName 13", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 15, ProductName = "ProductName 13", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 16, ProductName = "ProductName 17", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 17, ProductName = "ProductName 18", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 18, ProductName = "ProductName 19", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 19, ProductName = "ProductName 20", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 20, ProductName = "ProductName 23", StartDate = "2016/12/14" });
            list.Add(new Product() { ProductID = 21, ProductName = "ProductName 23", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 1, ProductName = "ProductName 23", StartDate = "2016/12/13" });
            list.Add(new Product() { ProductID = 23, ProductName = "ProductName 24", StartDate = "2016/12/15" });
            list.Add(new Product() { ProductID = 24, ProductName = "ProductName 25", StartDate = "2016/12/15" });
            list.Add(new Product() { ProductID = 25, ProductName = "ProductName 26", StartDate = "2016/12/15" });
            list.Add(new Product() { ProductID = 26, ProductName = "ProductName 27", StartDate = "2016/12/15" });
            list.Add(new Product() { ProductID = 27, ProductName = "ProductName 28", StartDate = "2016/12/15" });
            list.Add(new Product() { ProductID = 28, ProductName = "ProductName 29", StartDate = "2016/12/16" });
            list.Add(new Product() { ProductID = 29, ProductName = "ProductName 30", StartDate = "2016/12/16" });
            list.Add(new Product() { ProductID = 30, ProductName = "ProductName 31", StartDate = "2016/12/16" });

            return list.AsEnumerable();
        }
        public ActionResult Index()
        {
            GridModel model = GetGridModel();
            return View(model);
        }

        private GridModel GetGridModel()
        {

            GridModel gridModel = new GridModel();
            gridModel.ID = "gridModel";
            gridModel.AutoGenerateColumns = false;
            gridModel.PrimaryKey = "ProductID";
            gridModel.Width = "100%";
            gridModel.Height = "500px";
            gridModel.Virtualization = true;
            gridModel.VirtualizationMode = VirtualizationMode.Continuous;
           // gridModel.AvgRowHeight = "35px";
            gridModel.Columns = new List<GridColumn>();
            gridModel.Columns.Add(new GridColumn() { HeaderText = "Product ID", Key = "ProductID", DataType = "number" });
            gridModel.Columns.Add(new GridColumn() { HeaderText = "Product Name", Key = "ProductName", DataType = "string" });
            gridModel.Columns.Add(new GridColumn() { HeaderText = "Date", Key = "StartDate", DataType = "string" });
            gridModel.ResponseDataKey = "Data.Records";
            gridModel.DataSourceUrl = this.Url.Action("GetGridData");

            GridFiltering filtering = new GridFiltering() { Type = OpType.Remote, Inherit = true, Persist = true, Mode = FilterMode.Simple, FilterSummaryAlwaysVisible = false };
            //filtering.ColumnSettings.Add(new ColumnFilteringSetting() { ColumnKey = "StartDate", FilterType = FilterType.Date, DefaultExpressions = new List<DefaultFilterExpression>() { new DefaultFilterExpression() { Condition = "today", Expression = DateTime.UtcNow.Date.ToShortDateString(), Logic = "AND" } } });
            GridSorting sorting = new GridSorting() { Type = OpType.Local, Mode = SortingMode.Single };
            //sorting.ColumnSettings.Add(new ColumnSortingSetting() { ColumnIndex = 1, AllowSorting = true });
            GridGroupBy groupby = new GridGroupBy() { Type = OpType.Remote, GroupByDialogContainment = "window", InitialExpand = true };
            GridPaging paging = new GridPaging() { Type = OpType.Local, PageSize = 5 };
            GridHiding hiding = new GridHiding();
            GridColumnMoving moving = new GridColumnMoving();
            GridCellMerging cellmerging = new GridCellMerging();
            gridModel.Features.Add(filtering);
           // gridModel.Features.Add(sorting);
            //gridModel.Features.Add(groupby);
            gridModel.Features.Add(paging);
            //gridModel.Features.Add(hiding);
            //gridModel.Features.Add(moving);
            //gridModel.Features.Add(cellmerging);

            return gridModel;
        }


        public ActionResult GetGridData()
        {

            GridModel model = GetGridModel();
            model.DataSource = GetData().AsQueryable();
            JsonResult res = new JsonResult();
            res.Data = model.GetData();
            res.JsonRequestBehavior = JsonRequestBehavior.AllowGet;
            return res;

        }

    }
}
